/*

  Graph Class Header File
  Created by: Alejandro Gutierrez
  Created Date: 08/05/2007
  Last Modified Date: 07/05/2008
  University of South Florida

 Copyright (C) 2008  Alejandro Gutierrez Munoz

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include <iostream>
#include <string>
#include <vector>
#include <map>

using namespace std;

class graph
{
public:

	typedef vector< vector< float > > graphCurrents;

	graph(void);
	graph(const string&,map< string,double >&, double&, double&);
	graphCurrents getCurrents(map< string,double >&);
	string getGraphName(void) const {return graph_name;};
	string getGraphClass(void) const {return graph_class;};

	~graph(void);

private:

	string graph_name;
	string graph_class;
	vector< pair < int,string > > vertices;
	vector< vector< pair < int, float > > > adjacency_list;

	vector< vector< int > > getGroupN(void) const;
	vector< vector< vector< vector< int > > > > getGeodesics(void) const;
	vector< int > BFS(int,int) const;
	vector< int > Dijkstra(int,int) const;
	vector< float > findVoltages(int,int) const;

};
